<script>
    import { slide } from 'svelte/transition'
    import { sineOut } from 'svelte/easing'
    import ErrorAlert from 'components/ErrorAlert.svelte'
    import Avatar from 'components/User/Avatar.svelte'
    import Spinner from 'components/Icons/Spinner.svelte'
    import { user, awaitingAPI, postId } from 'store'
    import { post, get } from 'lib/fetch'
    import { validateSelf } from 'lib/validate'
    import { timeline } from 'lib/timeline'

    let content = ''
    let errors = []

    const transition = { duration: 150, easing: sineOut }

    const validate = async () => {
        errors = await validateSelf(['required', 'min:1'], content)
        return errors.length === 0
    }

    const sendResponse = async () => {
        if (!(await validate())) return
        const { req } = await post('/api/posts', {
            content,
            answer_to: $postId,
        })
        if (req.ok) {
            const { req, res: updatedPost } = await get(`/api/posts/${$postId}`)
            if (req.ok) {
                timeline.update(posts =>
                    posts.map(p => (+p.id === +$postId ? updatedPost : p))
                )
                content = ''
            }
        }
    }
</script>

<div
    class="reply-form"
    in:slide={{ ...transition, delay: 200 }}
    out:slide={transition}
>
    <Avatar src={$user?.avatar} name={$user?.name} medium />
    <div class="form-input">
        <input
            type="text"
            bind:value={content}
            on:input={() => (errors = [])}
            placeholder="Envoie ta réponse"
        />
        {#if errors.length > 0}
            <ErrorAlert>
                {#each errors as error, i}
                    {error}{i < errors.length - 1 ? ', ' : ''}
                {/each}
            </ErrorAlert>
        {/if}
    </div>
    <span>
        <button
            type="button"
            disabled={!content}
            on:click|preventDefault={sendResponse}>
            {#if $awaitingAPI}
                <Spinner />
            {:else}Envoyer{/if}
        </button>
    </span>
</div>

<style lang="postcss">
    .reply-form {
        @apply flex items-start flex-wrap mb-6 gap-x-2 px-8;

        .form-input {
            @apply flex-1;

            input {
                @apply w-full px-3 py-2 rounded-xl bg-blueGray-200 mb-2 appearance-none;

                &::placeholder {
                    @apply text-blueGray-900;
                }

                &:focus {
                    @apply outline-none ring-1 ring-teal-500 border-teal-500;
                }
            }
        }

        span {
            @apply w-full flex-none text-right;

            button {
                @apply p-2 bg-teal-500 text-teal-50 font-normal tracking-wide rounded-xl transition-colors duration-150 ease-out;

                &:hover {
                    @apply bg-teal-400 text-teal-800;
                }

                &:focus {
                    @apply outline-none ring-1 ring-teal-400 ring-opacity-50;
                }

                &:disabled {
                    @apply cursor-not-allowed bg-teal-200 text-teal-50;
                }
            }
        }
    }
</style>
